首页 > 代码库 > 字典树 Trie (HDU 1671)
字典树 Trie (HDU 1671)
Problem Description
Given a list of phone numbers, determine if it is consistent in the sense that no number is the prefix of another. Let’s say the phone catalogue listed these numbers:
1. Emergency 911
2. Alice 97 625 999
3. Bob 91 12 54 26
In this case, it’s not possible to call Bob, because the central would direct your call to the emergency line as soon as you had dialled the first three digits of Bob’s phone number. So this list would not be consistent.
1. Emergency 911
2. Alice 97 625 999
3. Bob 91 12 54 26
In this case, it’s not possible to call Bob, because the central would direct your call to the emergency line as soon as you had dialled the first three digits of Bob’s phone number. So this list would not be consistent.
Input
The first line of input gives a single integer, 1 <= t <= 40, the number of test cases. Each test case starts with n, the number of phone numbers, on a separate line, 1 <= n <= 10000. Then follows n lines with one unique phone number on each line. A phone number is a sequence of at most ten digits.
Output
For each test case, output “YES” if the list is consistent, or “NO” otherwise.
Sample Input
2 3 911 97625999 91125426 5 113 12340 123440 12345 98346
Sample Output
NO YES
题意 : 给出n个字符串 , 且任意两个字符串不存在前缀关系,那么输出yes, 否则输出no 。
思路 : 建立Trie ,val[]的值代表字符串是否为结束点 ,非0 代表是,0代表不是 。 然后再遍历n个字符串 , 计算每一个字符串的val[],统计出val[]的个数,假如val[]非0的个数大于1,说明这个串存在前缀,返回不满足。
#include <string.h> #include <stdio.h> int ch[100050][11]; int val[100050]; int sz; int idx(char c) { return c-'0'; } void inser(char *s , int v) { int u=0 , n=strlen(s); for(int i=0;i<n;i++) { int c=idx(s[i]); if( !ch[u][c] ) { // memset(ch[sz] ,0 ,sizeof(sz)); val[sz]=0; ch[u][c]=sz++; } u=ch[u][c]; } val[u]=v; } int Find(char *s ) { int i, n=strlen(s) , u=0 ,cnt=0; for(i=0;i<n;i++) { int c=idx(s[i]); u=ch[u][c]; if(val[u] != 0) cnt++; } if(cnt>1) return 0; else return 1; } char a[10005][11]; int main() { int T,n,i; scanf("%d%*c",&T); while(T--) { sz=1; memset(val,0,sizeof(val)); memset(ch,0,sizeof(ch)); scanf("%d%*c",&n); for(i=0; i<n;i++) { scanf("%s",a[i]); inser( a[i], 1 ); } for(i=0;i<n;i++) { if(!Find(a[i])) { printf("NO\n"); break; } } if(i == n) printf("YES\n"); } return 0; }
声明:以上内容来自用户投稿及互联网公开渠道收集整理发布,本网站不拥有所有权,未作人工编辑处理,也不承担相关法律责任,若内容有误或涉及侵权可进行投诉: 投诉/举报 工作人员会在5个工作日内联系你,一经查实,本站将立刻删除涉嫌侵权内容。